Skip to content

Rippling: Rest API schemas (part 3)

75 Rippling schemas with complete fields and constraints.

← Rest API operations · All schemas

Evaluate a leave program evaluation — response body — program results item directives

FieldTypePresenceDescription and constraints
$objectRootBookable directives emitted by this program.
balance_adjustmentsarrayOptionalBalance adjustment directives emitted by payable program results.
balance_adjustments[]ModelEach itemExpand Evaluate a leave program evaluation — response body — leave plan balance adjustments item
earningsarrayOptionalPayroll earning directives emitted by payable program results.
earnings[]ModelEach itemExpand Evaluate a leave program evaluation — response body — leave plan earnings item
leave_requestModelOptionalExpand Evaluate a leave program evaluation — response body — program results item directives leave request

Referenced models: Evaluate a leave program evaluation — response body — leave plan balance adjustments item, Evaluate a leave program evaluation — response body — leave plan earnings item, Evaluate a leave program evaluation — response body — program results item directives leave request

Evaluate a leave program evaluation — response body — program results item directives leave request

FieldTypePresenceDescription and constraints
$objectRootLeave request directive emitted by payable program results.
end_datestringOptionalRecommended leave request end date, if known.
leave_typestringRequired within parentLeave type to use if booking a leave request from the evaluation.
start_datestringRequired within parentRecommended leave request start date.
statusstringOptionalOptional leave request status to use when booking.

Evaluate a leave program evaluation — response body — program results item pay rate phases item

FieldTypePresenceDescription and constraints
$objectRoot
amountstringRequired within parentPay amount for this phase serialized as a decimal string.
currencystringOptionalISO 4217 currency code for this pay phase.
duration_daysJSONOptional
duration_days (anyOf 1)integerAlternativeNumber of days this phase lasts. Null means the phase runs to the window end.
duration_days (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
unitstringOptionalPay-rate unit for this phase, such as DAILY, WEEKLY, or BIWEEKLY.

Evaluate a leave program evaluation — response body — program results item program requirements item

FieldTypePresenceDescription and constraints
$objectRoot
blocks_paymentbooleanOptionalWhether this requirement blocks payment until resolved.
keystringRequired within parentMachine-readable requirement key.
summarystringRequired within parentHuman-readable requirement summary.

Evaluate a leave program evaluation — response body — program results item program validations item

FieldTypePresenceDescription and constraints
$objectRoot
data_sourcestringOptionalEvidence key or field path inspected by the validation.
messagestringRequired within parentHuman-readable validation message.
outcomestringRequired within parentValidation outcome.
Known values: PASSED, FAILED, UNKNOWN, ASSUMED
validation_funcstringRequired within parentMachine-readable validation function that produced this outcome.
valuestringOptionalObserved value at evaluation time, if available.

Execute a workflow action from Rippling Functions — request body — body

FieldTypePresenceDescription and constraints
$objectRoot
action_typestringRequired within parentOne of: run_query
payloadModelRequired within parentExpand Execute a workflow action from Rippling Functions — request body — body payload
workflow_definition_idstringRequired within parent

Referenced models: Execute a workflow action from Rippling Functions — request body — body payload

Execute a workflow action from Rippling Functions — request body — body payload

FieldTypePresenceDescription and constraints
$objectRoot
product_nameJSONOptional
product_name (anyOf 1)stringAlternative
product_name (anyOf 2)nullAlternative
querystringRequired within parent

Execute a workflow — response body

FieldTypePresenceDescription and constraints
$objectRootA single execution of a workflow: one launch of the workflow's current published version, with a status to poll until it reaches a terminal value.
Additional keys: not allowed
created_atstringRequired within parentWhen the workflow was launched, in UTC (ISO 8601).
Format: date-time
idstringRequired within parentUnique identifier for this workflow execution. Poll it with GET /workflows/{id}/executions/{execution_id}.
statusstringRequired within parentThe execution status. Transitional values are `pending`, `in_progress`, `waiting_for_response`, and `cancellation_pending`; terminal values are `completed`, `failed`, and `cancelled`. Poll until the status reaches a terminal value.

* `pending`: The execution is queued and has not started.
* `in_progress`: The workflow is executing.
* `waiting_for_response`: The execution is paused on a human input or approval step.
* `cancellation_pending`: A cancellation was requested and is being applied.
* `completed`: Every step finished successfully.
* `failed`: The execution stopped on an error.
* `cancelled`: The execution was cancelled before completing.
* `unknown`: The status could not be mapped. Contact support if this persists.
Known values: pending, in_progress, completed, failed, cancelled, cancellation_pending, waiting_for_response, unknown
version_idstringRequired within parentThe workflow version that ran. An execution always runs the workflow's current published version; the current version_id is available from GET /workflows/{id}.
workflow_idstringRequired within parentThe ID of the workflow this execution belongs to. Matches the {id} path parameter.

Export a package version manifest — response body

FieldTypePresenceDescription and constraints
$objectRootAdditional keys: not allowed
componentsarrayRequired within parentComplete desired component snapshot compiled from the Metadata SDK's defineManifest. Each entry requires its component type and full configuration for that type. An empty array creates an empty draft version; it cannot be published until components are added.
components[]objectEach item
components_to_deletearrayOptionalMust be omitted or an empty array. Versions are complete snapshots, so deletion instructions are rejected.
Default: []
Maximum items: 0
components_to_delete[]objectEach item
metadataModelRequired within parentExpand Export a package version manifest — response body — metadata

Referenced models: Export a package version manifest — response body — metadata

Export a package version manifest — response body — metadata

FieldTypePresenceDescription and constraints
$objectRootSource metadata from the SDK's defineManifest, retained with the snapshot. Use an empty object when no metadata is needed; package identity is supplied separately.
Additional keys: not allowed
descriptionstringOptionalOptional description of the source manifest, independent of the version description.
keystringOptionalOptional source-manifest identifier, retained on download; not the package key.
namestringOptionalOptional source-manifest label, retained on download; does not rename the package.

Extract existing metadata components — response body

FieldTypePresenceDescription and constraints
$objectRootAdditional keys: allowed
component_configsarrayRequired within parentReadable component configs for the selected roots. Dependencies the caller cannot read are omitted, so the result may not be deployable as-is.
component_configs[]ModelEach itemExpand Extract existing metadata components — response body — component configs item
context_completebooleanOptionalFor search-backed extraction, whether contextual expansion completed without warnings or unreadable components being omitted.
context_warningsarrayOptionalWarnings from search-backed contextual expansion.
context_warnings[]stringEach item
dependency_graphobjectRequired within parentSerialized dependency graph for the extracted package.
Additional keys: allowed
external_managed_dependenciesarrayOptional
external_managed_dependencies[]objectEach itemExternal managed dependency.
Additional keys: allowed
install_orderarrayRequired within parentTopological install order for the extracted package.
install_order[]objectEach itemComponent identifier.
Additional keys: allowed
root_componentsarrayRequired within parentComponents selected as extraction roots.
root_components[]ModelEach itemExpand Extract existing metadata components — response body — root components item

Referenced models: Extract existing metadata components — response body — component configs item, Extract existing metadata components — response body — root components item

Extract existing metadata components — response body — component configs item

FieldTypePresenceDescription and constraints
$objectRootA metadata component config. The `type` field selects the concrete component schema. Fetch type-specific fields from GET /metadata/schema/?type=<TYPE>.
Additional keys: allowed
typestringRequired within parentMetadata component type, such as CUSTOM_OBJECT or CUSTOM_OBJECT_FIELD.

Extract existing metadata components — response body — root components item

FieldTypePresenceDescription and constraints
$objectRootSelectable package root returned by metadata extraction.
Additional keys: allowed
identifierobjectOptionalIdentifier for the selected component.
Additional keys: allowed
namestringOptionalDisplay name for the selectable component.

Extract live package components and dependencies — request body — body

FieldTypePresenceDescription and constraints
$objectRootAdditional keys: not allowed
identifiersarrayRequired within parentComplete picker identifiers; fields depend on the component type.
Maximum items: 100
Minimum items: 1
identifiers[]objectEach item

Extract live package components and dependencies — response body

FieldTypePresenceDescription and constraints
$objectRoot
component_configsarrayRequired within parentFull packaging configurations for selected live components and their dependencies.
component_configs[]objectEach item
external_managed_dependenciesarrayRequired within parentRequired components owned by other managed packages, outside this snapshot.
external_managed_dependencies[]objectEach item
external_zobject_referencesarrayRequired within parentNative object and field references required in the destination company.
external_zobject_references[]objectEach item
has_omitted_unreadable_componentsbooleanRequired within parentTrue when extraction skipped a missing, deleted, or unreadable component, including a selected root or dependency. The returned snapshot is partial and must not be used to create a package version.
install_orderarrayRequired within parentComponent identifiers ordered for installation by the packaging dependency graph.
install_order[]objectEach item
omitted_componentsarrayRequired within parentMissing or deleted components skipped by the shared extractor, with identifiers and omission reasons. An empty list means no missing-component omissions were reported.
omitted_components[]ModelEach itemExpand Extract live package components and dependencies — response body — omitted components item

Referenced models: Extract live package components and dependencies — response body — omitted components item

Extract live package components and dependencies — response body — omitted components item

FieldTypePresenceDescription and constraints
$objectRoot
identifierobjectRequired within parentIdentifier of the selected component or dependency omitted from extraction.
messagestringRequired within parentExplanation of why the component was omitted.
reasonstringRequired within parentMachine-readable reason the component was omitted.
Known values: NOT_FOUND

Extract metadata components by identifier — request body — body

FieldTypePresenceDescription and constraints
$objectRootAdditional keys: not allowed
identifiersarrayRequired within parentMinimum items: 1
identifiers[]objectEach itemExact metadata component identifier, including its type.
Additional keys: allowed

Extract metadata components by identifier — response body

FieldTypePresenceDescription and constraints
$objectRootAdditional keys: not allowed
component_configsarrayRequired within parentReadable component configs for the requested roots. Unreadable dependencies are omitted, so the result may not be deployable as-is.
component_configs[]ModelEach itemExpand Extract existing metadata components — response body — component configs item
external_managed_dependenciesarrayRequired within parent
external_managed_dependencies[]objectEach itemExternal managed dependency.
Additional keys: allowed
install_orderarrayRequired within parentTopological install order for the extracted package.
install_order[]objectEach itemComponent identifier.
Additional keys: allowed

Referenced models: Extract existing metadata components — response body — component configs item

Get a metadata schema — response body

FieldTypePresenceDescription and constraints
$objectRootAdditional keys: allowed
best_practicesstringOptionalType-specific implementation guidance.
common_mistakesarrayOptionalCommon invalid inputs and their corrections.
common_mistakes[]ModelEach itemExpand Get a metadata schema — response body — common mistakes item
config_schemaobjectRequired within parentJSON Schema for a full deployable component config.
Additional keys: allowed
descriptionstringOptionalShort description of the component type.
display_namestringOptionalHuman-readable component type name.
examplesarrayOptionalValid example configs for this component type.
examples[]objectEach itemExample metadata component config.
Additional keys: allowed
identifier_schemaobjectRequired within parentJSON Schema for identifying an existing component.
Additional keys: allowed
typestringRequired within parentMetadata component type.
usage_guidestringOptionalType-specific authoring guidance.

Referenced models: Get a metadata schema — response body — common mistakes item

Get a metadata schema — response body — common mistakes item

FieldTypePresenceDescription and constraints
$objectRoot
messagestringRequired within parentExplanation of the correction.
rightstringRequired within parentCorrected example.
wrongstringRequired within parentInvalid or discouraged example.

Get a package version — response body

FieldTypePresenceDescription and constraints
$objectRoot
componentsarrayOptionalComponents included in this version. Function identifiers provide valid post_install_function values.
components[]objectEach itemAdditional keys: allowed
components[].identifierobjectRequired within parentAdditional keys: allowed
components[].identifier.api_namestringOptionalThe portable API name. Present on FUNCTION identifiers; other component kinds may use different identity fields.
components[].identifier.typestringRequired within parentThe component kind. FUNCTION identifies a packaged Function.
created_atstringRequired within parentRecord creation date
descriptionstringOptionalThe description of the package version
idstringRequired within parentIdentifier field
is_publishedbooleanOptionalWhether this package version has been published
package_display_namestringOptionalThe display name of the parent package
package_idstringOptionalThe ID of the parent package
package_keystringOptionalThe package key of the parent package
post_install_functionJSONOptional
post_install_function (anyOf 1)stringAlternativeThe portable API name of a Function component included in this version. Find valid values in components entries with identifier.type equal to FUNCTION, using identifier.api_name. Set through PATCH on an unpublished version after adding the Function. Creation rejects this field. Null clears the hook and omission preserves it. Removing the Function clears the setting when the version is refreshed or copied.
post_install_function (anyOf 2)nullAlternative
updated_atstringRequired within parentRecord update date
version_numberstringRequired within parentThe semantic version number for this package version

Get hire requirements — response body

FieldTypePresenceDescription and constraints
$objectRootPublic GET /hire-requirements/ body. Shape matches hiring's catalog JSON.
Additional keys: not allowed
country_codestringRequired within parentISO 3166-1 alpha-2 country code used for the lookup.
fields_by_grouparrayRequired within parentHiring-owned field catalog grouped by request section.
hire_typestringRequired within parentHire type for this catalog. POST /hires/ uses the same value. An omitted POST value defaults to direct_hire.
required_groupsarrayRequired within parentGroups you must send for this country.
required_groups[]stringEach item
requirements_versionstringRequired within parentBaseline requirement contract version for this selector tuple.
unsupported_fieldsarrayOptionalPublic field paths that are not writable for this selector tuple.
unsupported_fields[]stringEach item
warningsarrayOptionalNon-fatal warnings for this lookup.
warnings[]stringEach item

Get the company and administrator role used to enter a developer sandbox — response body

FieldTypePresenceDescription and constraints
$objectRootCompany and administrator role used to enter a developer sandbox.
admin_role_idJSONRequired within parent
admin_role_id (anyOf 1)stringAlternativeThe unique identifier of the sandbox company's administrator role.
admin_role_id (anyOf 2)nullAlternative
target_company_idJSONRequired within parent
target_company_id (anyOf 1)stringAlternativeThe unique identifier of the company inside the sandbox.
target_company_id (anyOf 2)nullAlternative

List App Shop publisher users — response body — results item

FieldTypePresenceDescription and constraints
$objectRootApp Shop Publishers Super Group member.
emailstringOptionalThe publisher's work or invite email
full_namestringOptionalThe publisher's full name
idstringOptionalRole ID of a member of the App Shop Publishers Super Group
is_super_adminbooleanOptionalWhether this publisher is a Super Admin
role_statestringOptionalRole state: INIT, HIRED, ACCEPTED, ACTIVE, or TERMINATED
Known values: INIT, HIRED, ACCEPTED, ACTIVE, TERMINATED

List Custom App — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
api_namestringRequired within parentThe unique api name of the custom app
created_atstringOptionalRecord creation date
descriptionstringOptionalThe description of the custom app
iconstringOptionalThe icon URL of the custom app
idstringOptionalIdentifier field
namestringRequired within parentThe display name of the custom app
pagesarrayOptionalThe pages of the custom app
pages[]ModelEach itemExpand Update a Custom App — response body — pages item
updated_atstringOptionalRecord update date

Referenced models: Update a Custom App — response body — pages item

List Custom Page — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringOptionalRecord creation date
created_bystringOptionalThe ID of the role that created the page
function_idstringOptionalThe ID of the Rippling Function that renders this page
idstringOptionalIdentifier field
namestringOptionalThe display name of the custom page
updated_atstringOptionalRecord update date
updated_bystringOptionalThe ID of the role that last modified the page

List Setting — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
api_namestringOptionalThe unique api name of the setting
boolean_valuebooleanOptionalBoolean value of the setting, if it has boolean data type
created_atstringRequired within parentRecord creation date
data_typestringOptionalData type of the setting
display_namestringOptionalThe display name of setting
idstringRequired within parentIdentifier field
number_valueJSONOptional
number_value (anyOf 1)numberAlternativeNumber value of the setting, if it has number data type
number_value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
secret_valuestringOptionalSecret value of the setting, if it has secret data type
string_valuestringOptionalString value of the setting, if it has string data type
updated_atstringRequired within parentRecord update date

List Sites — response body — meta

FieldTypePresenceDescription and constraints
$objectRootA list of redacted fields.
redacted_fieldsarrayOptional
redacted_fields[]objectEach item
redacted_fields[].namestringOptionalThe name for the redacted field
redacted_fields[].reasonstringOptionalThe reason for the redaction

List Sites — response body — results item

FieldTypePresenceDescription and constraints
$objectRootResponse/resource shape for a custom site.
admin_group_idstringOptionalThe admin group id for the custom site
api_namestringOptionalThe unique api name of the custom site
created_atstringOptionalRecord creation date
created_bystringOptionalThe ID of the role that created the custom site
current_bundle_idstringOptionalThe active bundle id for the custom site
descriptionstringOptionalThe optional description of the custom site
idstringOptionalIdentifier field
logostringOptionalA Rippling-owned logo URL for the custom site
namestringOptionalThe display name of the custom site
viewer_group_idstringOptionalThe viewer group id for the custom site

List agent deployments — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
deployment_idstringOptionalThe ID of the deployment
diagnosticsarrayOptionalDiagnostics emitted while creating the deployment
diagnostics[]ModelEach itemExpand Retrieve an agent deployment — response body — diagnostics item
is_activebooleanOptionalWhether the deployment is active
outcomestringOptionalThe deployment outcome
source_digeststringOptionalThe digest of the deployed source revision
source_revision_versionJSONOptional
source_revision_version (anyOf 1)integerAlternativeThe source revision version deployed by the control plane
source_revision_version (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
stagestringOptionalThe deployment stage

Referenced models: Retrieve an agent deployment — response body — diagnostics item

List agent session events — response body — events item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringOptionalWhen the event was created
event_idstringOptionalThe ID of the session event
event_typestringOptionalThe event type
fieldsobjectOptionalStructured event fields
levelstringOptionalThe event severity level
messagestringOptionalThe event message
sequenceJSONOptional
sequence (anyOf 1)integerAlternativeThe event sequence number
sequence (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$

List agent sessions — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
agent_idstringRequired within parentThe ID of the agent to run
created_atstringRequired within parentRecord creation date
error_messagestringOptionalThe session error message
idstringRequired within parentIdentifier field
langsmith_thread_idstringOptionalThe stable LangSmith thread identifier for this session
outputobjectOptionalThe output of the session
promptstringRequired within parentThe prompt to send to the agent
session_resume_receiptobjectOptionalReceipt that ACP restored the requested session resume state
session_resume_receipt.statusstringOptionalThe session resume state restore status
statusstringOptionalThe status of the session. Possible values: `awaiting_approval`: someone else requested this session on your behalf, and it is waiting for your approval before it starts; `active`: the agent is running; `idle`: the session is open and waiting for more work; `waiting_on_user`: the agent is waiting for user input; `suspended`: the session is paused; `completed`: the session finished successfully; `ended`: the session was explicitly ended; `failed`: execution failed or the approval request expired or became invalid before execution; `cancelled`: execution was cancelled or the approval request was rejected or cancelled. The Platform API does not support requesting delegated execution or managing approvals.
submission_idstringOptionalReceipt for correlating agent.submission.settled events after create or append-message writes
updated_atstringRequired within parentRecord update date

List agent source revisions — response body — results item

FieldTypePresenceDescription and constraints
$objectRootList representation of an agent source revision without source contents.
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
source_digeststringOptionalThe digest of the source revision
updated_atstringRequired within parentRecord update date
versionJSONOptional
version (anyOf 1)integerAlternativeThe version number of the source revision
version (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$

List agents — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
api_namestringRequired within parentThe API name of the agent
created_atstringRequired within parentRecord creation date
descriptionstringOptionalThe description of the agent
idstringRequired within parentIdentifier field
is_for_evalsbooleanOptionalWhether the agent is used for evaluations
namestringRequired within parentThe display name of the agent
updated_atstringRequired within parentRecord update date

List app users — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
Maps a Rippling worker (if any) to their user account in a third-party
app (e.g. Slack, Jira, GitHub). Sourced from SpokeUser records.

Includes orphan accounts — third-party app accounts with no matching
Rippling worker (`worker_id=None`, `match_state=NOT_MATCHED`). These are
the primary signal for IT-admin triage. Uses `BaseResourceDTO` rather
than `BaseEmployeeResourceDTO` so the platform's role-based auto-filter
does not silently drop orphans for non-admin tokens. Company scoping is
enforced explicitly in `AppUsersAPIViewSet.get_queryset`; the `app-users.read`
scope is the access gate.

Resource name aligns with how the product surfaces these in the UI
("Slack account", "GitHub account") and matches the equivalent concept
in Okta's IAM API (AppUser).

Designed for point lookups: list endpoint requires at least one filter
on `worker_id` or `spoke_user_identifier` to prevent bulk enumeration of the
org's identity graph across connected apps.

`spoke_user_identifier` reads `SpokeUser.spokeId` — the user identifier
stored for the third-party account. Depending on the integration, this may
be an email, username, account handle, or app-specific user id.
app_display_namestringOptionalHuman-readable display name for the third-party app (e.g. 'Slack', 'GitHub'). Sourced from the customer-configured SpokeOwner.app_display_name; falls back to a title-cased app handle when the customer hasn't set one.
app_handlestringOptionalMachine-readable identifier for the third-party app (e.g. 'slack', 'jira', 'asana'). Stable across the App Shop catalog.
created_atstringRequired within parentRecord creation date
external_emailstringOptionalThe user's email address in the third-party app, if known. Null when the app does not expose an email or Rippling did not capture one.
external_usernamestringOptionalThe user's display name in the third-party app, if known. Null when the app does not surface a separate username.
idstringRequired within parentIdentifier field
match_statestringOptionalWhether this third-party account has been matched to a Rippling worker.
Known values: MATCHED, NOT_MATCHED, IGNORED
push_statestringOptionalProvisioning lifecycle state of this account in the third-party app.
Known values: INIT, EMPLOYEE_CONFIRMATION_PENDING, EMPLOYEE_CONFIRMATION_ACCEPTED, EMPLOYEE_CONFIRMATION_REJECTED, INVITE_PENDING, INVITE_CONFIRMED, INVITE_FAILED, CREATE_PENDING, CREATE_CONFIRMED, CREATE_FAILED, DELETE_PENDING, DELETE_CONFIRMED, DELETE_FAILED, SUSPEND_PENDING, SUSPEND_CONFIRMED, SUSPEND_FAILED
spoke_user_identifierstringOptionalIdentifier for the user's account in the third-party app workspace. Depending on the integration, this may be an email, username, account handle, or app-specific user id.
updated_atstringRequired within parentRecord update date
workerModelOptionalExpand Retrieve a specific app user — response body — worker
worker_idstringOptionalID of the Rippling worker associated with this external app account.

Referenced models: Retrieve a specific app user — response body — worker

List attribute change logs — rest Api list Job Codes Job Code Id Change Log — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
attribute_changesarrayOptionalList of attributes that were modified as part of the change.
attribute_changes[]ModelEach itemExpand List attribute change logs — rest Api list Job Codes Job Code Id Change Log — response body — results item attribute changes item
changed_by_workerobjectOptionalWorker who made the change

Expandable field
changed_by_worker.business_partnersarrayOptionalWorker's assigned business partners. This field is only populated when explicitly requested via the expand parameter (e.g., ?expand=business_partners). When expanded, returns an empty list ([]) if the worker has no business partners.

Expandable field
changed_by_worker.business_partners[]ModelEach itemExpand Retrieve a specific worker — response body — business partners item
changed_by_worker.business_partners_idarrayOptionalWorker's assigned business partners unique identifiers. Returns an empty list ([]) if the worker has no business partners.
changed_by_worker.business_partners_id[]stringEach item
changed_by_worker.citizenshipstringOptionalThe countries that the worker has citizenship in.
Known values: AF, AX, AL, DZ, AS, AD, AO, AI, AQ, AG, AR, AM, AW, AU, AT, AZ, BS, BH, BD, BB, BY, BE, BZ, BJ, BM, BT, BO, BQ, BA, BW, BV, BR, IO, BN, BG, BF, BI, CV, KH, CM, CA, KY, CF, TD, CL, CN, CX, CC, CO, KM, CG, CD, CK, CR, CI, HR, CW, CY, CZ, DK, DJ, DM, DO, EC, EG, SV, GQ, ER, EE, SZ, ET, FK, FO, FJ, FI, FR, GF, PF, TF, GA, GM, GE, DE, GH, GI, GR, GL, GD, GP, GU, GT, GG, GN, GW, GY, HT, HM, VA, HN, HK, HU, IS, IN, ID, IQ, IR, IE, IM, IL, IT, JM, JP, JE, JO, KZ, KE, KI, KR, XK, KW, KG, LA, LV, LB, LS, LR, LY, LI, LT, LU, MO, MG, MW, MY, MV, ML, MT, MH, MQ, MR, MU, YT, MX, FM, MD, MC, MN, ME, MS, MA, MZ, MM, NA, NR, NP, NL, AN, NC, NZ, NI, NE, NG, NU, NF, MK, MP, NO, OM, PK, PW, PS, PA, PG, PY, PE, PH, PN, PL, PT, PR, QA, RO, RU, RW, RE, BL, SH, KN, LC, MF, PM, VC, WS, SM, ST, SA, SN, RS, SC, SL, SG, SX, SY, SK, SI, SB, SO, ZA, GS, SS, ES, LK, SD, SR, SJ, SE, CH, TW, TJ, TZ, TH, TL, TG, TK, TO, TT, TN, TR, TM, TC, TV, UG, UA, AE, GB, US, UM, UY, UZ, VU, VE, VN, VG, VI, WF, EH, YE, ZM, ZW
changed_by_worker.compensationModelOptionalExpand Retrieve a specific worker — response body — compensation
changed_by_worker.compensation_gradeobjectOptionalThe compensation grade assigned to the worker, if any.
changed_by_worker.compensation_grade.idstringOptionalThe compensation grade's unique identifier.
changed_by_worker.compensation_grade.labelstringOptionalThe compensation grade's label.
changed_by_worker.compensation_idstringOptionalThe compensation package for the worker.
changed_by_worker.countrystringOptionalThe worker's country.
Known values: AF, AX, AL, DZ, AS, AD, AO, AI, AQ, AG, AR, AM, AW, AU, AT, AZ, BS, BH, BD, BB, BY, BE, BZ, BJ, BM, BT, BO, BQ, BA, BW, BV, BR, IO, BN, BG, BF, BI, CV, KH, CM, CA, KY, CF, TD, CL, CN, CX, CC, CO, KM, CG, CD, CK, CR, CI, HR, CW, CY, CZ, DK, DJ, DM, DO, EC, EG, SV, GQ, ER, EE, SZ, ET, FK, FO, FJ, FI, FR, GF, PF, TF, GA, GM, GE, DE, GH, GI, GR, GL, GD, GP, GU, GT, GG, GN, GW, GY, HT, HM, VA, HN, HK, HU, IS, IN, ID, IQ, IR, IE, IM, IL, IT, JM, JP, JE, JO, KZ, KE, KI, KR, XK, KW, KG, LA, LV, LB, LS, LR, LY, LI, LT, LU, MO, MG, MW, MY, MV, ML, MT, MH, MQ, MR, MU, YT, MX, FM, MD, MC, MN, ME, MS, MA, MZ, MM, NA, NR, NP, NL, AN, NC, NZ, NI, NE, NG, NU, NF, MK, MP, NO, OM, PK, PW, PS, PA, PG, PY, PE, PH, PN, PL, PT, PR, QA, RO, RU, RW, RE, BL, SH, KN, LC, MF, PM, VC, WS, SM, ST, SA, SN, RS, SC, SL, SG, SX, SY, SK, SI, SB, SO, ZA, GS, SS, ES, LK, SD, SR, SJ, SE, CH, TW, TJ, TZ, TH, TL, TG, TK, TO, TT, TN, TR, TM, TC, TV, UG, UA, AE, GB, US, UM, UY, UZ, VU, VE, VN, VG, VI, WF, EH, YE, ZM, ZW
changed_by_worker.country_fieldsModelOptionalExpand Retrieve a specific worker — response body — country fields
changed_by_worker.created_atstringRequired within parentRecord creation date
changed_by_worker.custom_fieldsarrayOptionalCustom field values defined on the Employee object for this worker

Expandable field
changed_by_worker.custom_fields[]JSONEach itemAdditional keys: see wildcard field
changed_by_worker.custom_fields[].*JSONAdditional keys
changed_by_worker.date_of_birthstringOptionalThe worker's date of birth.
changed_by_worker.departmentModelOptionalExpand Retrieve a specific worker — response body — department
changed_by_worker.department_idstringOptionalThe worker's assigned department.
changed_by_worker.employment_typeModelOptionalExpand Retrieve a specific worker — response body — employment type
changed_by_worker.employment_type_idstringOptionalThe worker's employment type.
changed_by_worker.end_datestringOptionalThe end date of the worker.
changed_by_worker.ethnicitystringOptionalThe identified ethnicity of the worker, if specified.
Known values: HISPANIC_OR_LATINO, WHITE, BLACK_OR_AFRICAN_AMERICAN, NATIVE_HAWAIIAN_OR_OTHER_PACIFIC_ISLANDER, ASIAN, AMERICAN_INDIAN_OR_ALASKA_NATIVE, TWO_OR_MORE_RACES, MIDDLE_EASTERN_OR_NORTH_AFRICAN, DECLINE_TO_SELF_IDENTIFY, AFRICAN, COLOURED, INDIAN, OTHER, PREFER_NOT_TO_SAY
changed_by_worker.genderstringOptionalThe gender of the worker, if specified.
Known values: MALE, FEMALE, NONBINARY, UNDETERMINED, DIVERSE, DOES_NOT_APPLY, PREFER_NOT_TO_SAY
changed_by_worker.idstringRequired within parentIdentifier field
changed_by_worker.is_managerbooleanOptionalWhether the worker is a manager
changed_by_worker.job_functionobjectOptionalThe worker's job function. When expanded, this field requires `job-functions.read`.

Expandable field
changed_by_worker.job_function.created_atstringRequired within parentRecord creation date
changed_by_worker.job_function.idstringRequired within parentIdentifier field
changed_by_worker.job_function.namestringOptionalDisplayed name of the job function
changed_by_worker.job_function.updated_atstringRequired within parentRecord update date
changed_by_worker.job_function_idstringOptionalID of the worker's job function.
changed_by_worker.legal_entityModelOptionalExpand Retrieve a specific worker — response body — legal entity
changed_by_worker.legal_entity_idstringOptionalThe worker's associated legal entity.
changed_by_worker.levelModelOptionalExpand Retrieve a specific worker — response body — level
changed_by_worker.level_idstringOptionalThe level of the worker.
changed_by_worker.locationobjectOptionalThe location that the worker is mapped to for tax purposes. In the case that a worker is remote, the location's type is remote.
changed_by_worker.location.typestringRequired within parentThe type of location.
Known values: REMOTE, WORK
changed_by_worker.location.work_location_idstringRequired within parentThe work location, if the worker isn't remote.
changed_by_worker.managerModelOptionalExpand Retrieve a specific worker — response body — manager
The worker's manager.

Expandable field
changed_by_worker.manager_idstringOptionalThe worker's manager.
changed_by_worker.numberJSONOptional
changed_by_worker.number (anyOf 1)integerAlternativeThe worker's number within the organization.
changed_by_worker.number (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
changed_by_worker.original_start_datestringOptionalThe worker's earliest start date across their employment history, excluding INIT roles.
changed_by_worker.overtime_exemptionstringOptionalThe worker's overtime exemption status.
Known values: EXEMPT, NON_EXEMPT
changed_by_worker.pay_schedule_idstringOptionalThe ID of the pay schedule currently associated with the worker.
changed_by_worker.personal_emailstringOptionalThe worker's associated personal email address.
changed_by_worker.racestringOptionalThe identified race of the worker, if specified.
Known values: BLACK, BROWN, CHINESE, EURASIAN, INDIAN, INDIGENOUS, MALAY, WHITE, YELLOW, NOT_INFORMED, OTHER
changed_by_worker.start_datestringOptionalThe start date of the worker.
changed_by_worker.statusstringOptionalThe worker's status within the organization.
Known values: INIT, HIRED, ACCEPTED, ACTIVE, TERMINATED
changed_by_worker.teamsarrayOptionalThe worker's assigned teams.

Expandable field
changed_by_worker.teams[]ModelEach itemExpand Update a team — response body — parent
changed_by_worker.teams_idarrayOptionalThe worker's assigned teams.
changed_by_worker.teams_id[]stringEach item
changed_by_worker.termination_detailsobjectOptionalThe details of the worker's termination, if applicable.
changed_by_worker.termination_details.reasonstringOptionalThis is a description that will be custom to each Rippling company.
changed_by_worker.termination_details.typestringOptionalThe termination type indicates whether the termination was voluntary or involuntary.
Known values: VOLUNTARY, INVOLUNTARY, RETIREMENT, DEATH, ABANDONMENT, OFFER_DECLINED, RESCIND, RENEGE
changed_by_worker.titlestringOptionalThe worker's title.
changed_by_worker.title_effective_datestringOptionalTitle effective date
changed_by_worker.updated_atstringRequired within parentRecord update date
changed_by_worker.userModelOptionalExpand Retrieve a specific worker — response body — user
changed_by_worker.user_idstringOptionalThe worker's associated user.
changed_by_worker.work_emailstringOptionalThe worker's associated work email address.
changed_by_worker.work_scheduleobjectOptionalThe worker's scheduled working hours for each day of the week.
Additional keys: see wildcard field
changed_by_worker.work_schedule.*ModelAdditional keysExpand Retrieve a specific worker — response body — work schedule value
changed_by_worker_idstringOptionalIdentifier of worker who made the change
created_atstringOptionalThe time the change was requested by worker
effective_from_datestringOptionalThe time the change was scheduled to take effect on
idstringRequired within parentIdentifier field
reasonstringOptionalReason provided by worker for making the change
updated_atstringOptionalThe time the change was applied

Referenced models: List attribute change logs — rest Api list Job Codes Job Code Id Change Log — response body — results item attribute changes item, Retrieve a specific worker — response body — business partners item, Update a team — response body — parent, Retrieve a specific worker — response body — work schedule value, Retrieve a specific worker — response body — manager, Retrieve a specific worker — response body — compensation, Retrieve a specific worker — response body — country fields, Retrieve a specific worker — response body — department, Retrieve a specific worker — response body — employment type, Retrieve a specific worker — response body — legal entity, Retrieve a specific worker — response body — level, Retrieve a specific worker — response body — user

List attribute change logs — rest Api list Job Codes Job Code Id Change Log — response body — results item attribute changes item

FieldTypePresenceDescription and constraints
$objectRoot
attribute_namestringOptionalThe name of attribute changed.
new_attribute_valueobjectOptionalNew value of attribute, after the change
old_attribute_valueobjectOptionalOld value of attribute, before the change.

List available filters for a report — response body — data item

FieldTypePresenceDescription and constraints
$objectRootDescribes a field the client can filter on when running a report
field_idstringRequired within parentStable field identifier used when applying filters
field_namestringRequired within parentHuman-readable display name of the field
operatorsarrayRequired within parentOperators supported by this field
operators[]stringEach item
typestringRequired within parentData type of a filterable field
Known values: string, number, date, datetime, enum, boolean

List background check candidates — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
Background Check Candidate DTO.

Represents a candidate who has been submitted for background check screening.

Required on Create (but nullable on read for legacy rows):
- email: Required for new candidates, but may be null on read for legacy rows
- external_id: Required for new candidates, but may be null on read for legacy rows

Optional Fields:
- owner_id: May be null if no provider is associated
- first_name: May be null if name is not available
- last_name: May be null if name is not available
- middle_name: May be null if not provided

Sensitive Fields:
- first_name, last_name, middle_name: Name fields are PII marked as sensitive in the model
- These do not require separate OAuth scopes beyond the resource-level scopes
(background-check-candidates.read / .read-write) because they are not updating
role or worker data, only storing candidate names for background check processing

Note: first_name, last_name, and middle_name are NOT filterable.
Only external_id, email, created_at, and updated_at support filtering.
created_atstringOptionalThe timestamp when the candidate was created.
emailstringRequired within parentThe email address of the candidate. Required on create, but may be null on read for legacy rows.
external_idstringRequired within parentThe provider's unique identifier for the candidate. Required on create, but may be null on read for legacy rows. Can only be set once (during creation or when null). Cannot be changed after being set.
first_namestringOptionalThe first name of the candidate.
idstringOptionalThe unique identifier of the background check candidate.
last_namestringOptionalThe last name of the candidate.
middle_namestringOptionalThe middle name of the candidate.
owner_idstringOptionalThe ID of the background check provider (OAuth spoke owner).
updated_atstringOptionalThe timestamp when the candidate was last updated.

List bill payments — response body — results item

FieldTypePresenceDescription and constraints
$objectRootA bill payment visible to the caller, including its invoice and payment details.
accounting_datestringOptionalDate the transaction is booked in the accounting system, as an ISO 8601 date (YYYY-MM-DD).
approval_statusstringOptionalApproval state of the bill. `DRAFT`: not submitted. `PENDING`: awaiting required information before submission. `REQUESTED`: awaiting approval. `APPROVED`: approved. `REJECTED`: rejected. `FINALIZED`: finalized for payment. `ACTIONED`: paid. `CANCELLED`: cancelled. `FAILED`: payment failed.
Known values: DRAFT, PENDING, REQUESTED, APPROVED, REJECTED, FINALIZED, ACTIONED, CANCELLED, FAILED
attachmentsarrayOptionalURLs of other attached files.
attachments[]stringEach item
check_datestringOptionalDate the company is debited, as an ISO 8601 date. Null when not set.
company_amountobjectOptionalAmount in the company's headquarters currency. The `value` is a decimal string.
company_amount.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
company_amount.valueJSONOptional
company_amount.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
company_amount.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
created_atstringRequired within parentRecord creation date
credit_methodstringOptionalHow the vendor is paid: ACH, WIRE, CHECK, GLOBAL_ORDER, EXISTING_CORPORATE_CARD, or MANUALLY_PAID.
Known values: ACH, WIRE, CHECK, GLOBAL_ORDER, EXISTING_CORPORATE_CARD, MANUALLY_PAID, PAID_IN_FULL_VIA_VENDOR_CREDIT
debit_methodstringOptionalHow the company is debited: ACH, WIRE, EXISTING_CORPORATE_CARD, or MANUALLY_PAID.
Known values: ACH, WIRE, EXISTING_CORPORATE_CARD, MANUALLY_PAID
due_datestringOptionalInvoice due date, as an ISO 8601 date. A draft can omit it.
entity_idstringOptionalID of the legal entity the transaction belongs to. Use it with `/company-legal-entities/{id}/`.
estimated_payment_arrivalstringOptionalWhen the vendor is expected to receive the payment, as an ISO 8601 date-time in UTC. Null when not set.
gl_sync_statestringOptionalState of the sync to the accounting system. `NOT_FINALIZED`: not ready for accounting review. `FOR_REVIEW`: ready for accounting review. `PENDING_SYNC`: sync is in progress. `SYNCED`: synced to the accounting system. `ERROR`: sync failed. `DO_NOT_SYNC`: marked to be excluded from sync. `EXPORTED`: exported for accounting. `NOT_SYNCABLE`: this record cannot be synced. `AUTO_SYNC`: ready to be synced automatically. Null when no sync state is set.
Known values: NOT_FINALIZED, FOR_REVIEW, PENDING_SYNC, SYNCED, ERROR, DO_NOT_SYNC, EXPORTED, NOT_SYNCABLE, AUTO_SYNC
gl_vendorobjectOptionalVendor in the connected accounting system.
gl_vendor.gl_vendor_idstringOptionalID of the vendor in the accounting system.
gl_vendor.idstringOptionalID of the accounting vendor in Rippling.
gl_vendor.namestringOptionalName of the vendor in the accounting system.
global_purposestringOptionalPurpose code for an international payment. Null for domestic payments.
idstringRequired within parentIdentifier field
invoice_numberstringOptionalInvoice number. Null when the bill has no invoice number.
line_itemsarrayOptionalBill line items, including accounting, tax, quantity, and term details.
line_items[]ModelEach itemExpand Retrieve a specific bill payment — response body — line items item
memostringOptionalMemo entered on the transaction.
merchant_amountobjectOptionalAmount charged by the merchant, in the merchant currency. The `value` is a decimal string.
merchant_amount.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
merchant_amount.valueJSONOptional
merchant_amount.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
merchant_amount.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
parent_bill_idstringOptionalID of the bill this payment was split from. Use it with `/bill-payments/{id}/`. Null when it is not a split bill.
payment_amountobjectOptionalAmount paid to the vendor, in the payment currency. The value is a decimal string.
payment_amount.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
payment_amount.valueJSONOptional
payment_amount.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
payment_amount.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
payment_method_feeobjectOptionalPayment method fee, in the company's headquarters currency. The `value` is a decimal string. Zero when there is no fee.
payment_method_fee.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
payment_method_fee.valueJSONOptional
payment_method_fee.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
payment_method_fee.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
payment_schedule_settingstringOptionalSCHEDULE_NOW when a debit date was chosen; SKIP_FOR_NOW when choosing one was skipped.
Known values: SCHEDULE_NOW, SKIP_FOR_NOW
payment_velocitystringOptionalHow fast the vendor is paid after `check_date`: `TWO_DAY` (accelerated, 2 business days) or `FOUR_DAY` (standard, 4 business days).
Known values: TWO_DAY, FOUR_DAY
receiptstringOptionalURL of the receipt file.
scheduled_payment_datestringOptionalDate used to estimate vendor payment, as an ISO 8601 date. Null when not set.
submitter_idstringOptionalID of the bill manager who submitted the bill. Use it with `/workers/{id}/`. Can differ from `worker_id`. Null before submission.
transaction_datestringOptionalInvoice date, as an ISO 8601 date-time in UTC. Null when not set.
transaction_typestringOptionalType of transaction: `BILL_PAYMENT`.
Known values: BILL_PAYMENT
updated_atstringRequired within parentRecord update date
vendorobjectOptionalVendor the purchase was made from.
vendor.idstringOptionalID of the vendor.
vendor.namestringOptionalName of the vendor.
vendor_memostringOptionalMemo included on the payment to the vendor. Supported for ACH; null when not set.
vendor_paid_datestringOptionalDate the vendor is paid, as an ISO 8601 date. Null until paid.
worker_idstringOptionalID of the worker who made the transaction. Use it with `/workers/{id}/`.

Referenced models: Retrieve a specific bill payment — response body — line items item

List bills — response body — results item

FieldTypePresenceDescription and constraints
$objectRootA bill visible to the caller, including its invoice and payment details.
accounting_datestringOptionalDate the transaction is booked in the accounting system, as an ISO 8601 date (YYYY-MM-DD).
approval_statusstringOptionalApproval state of the bill. `DRAFT`: not submitted. `PENDING`: awaiting required information before submission. `REQUESTED`: awaiting approval. `APPROVED`: approved. `REJECTED`: rejected. `FINALIZED`: finalized for payment. `ACTIONED`: paid. `CANCELLED`: cancelled. `FAILED`: payment failed.
Known values: DRAFT, PENDING, REQUESTED, APPROVED, REJECTED, FINALIZED, ACTIONED, CANCELLED, FAILED
attachmentsarrayOptionalOther attached files, including filenames and recorded upload metadata.
attachments[]ModelEach itemExpand Retrieve a specific bill — response body — attachments item
company_amountobjectOptionalAmount in the company's headquarters currency. The `value` is a decimal string.
company_amount.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
company_amount.valueJSONOptional
company_amount.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
company_amount.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
created_atstringRequired within parentRecord creation date
credit_methodstringOptionalHow the vendor is paid: ACH, WIRE, CHECK, GLOBAL_ORDER, EXISTING_CORPORATE_CARD, MANUALLY_PAID, or PAID_IN_FULL_VIA_VENDOR_CREDIT. GLOBAL_ORDER is an international transfer. PAID_IN_FULL_VIA_VENDOR_CREDIT means vendor credits cover the full bill, with no cash payment.
Known values: ACH, WIRE, CHECK, GLOBAL_ORDER, EXISTING_CORPORATE_CARD, MANUALLY_PAID, PAID_IN_FULL_VIA_VENDOR_CREDIT
due_datestringOptionalInvoice due date, as an ISO 8601 date. A draft can omit it.
entity_idstringOptionalID of the legal entity the transaction belongs to. Use it with `/company-legal-entities/{id}/`.
estimated_payment_arrivalstringOptionalDate the vendor is expected to receive the payment, as an ISO 8601 date. Null when not set.
gl_sync_statestringOptionalState of the sync to the accounting system. `NOT_FINALIZED`: not ready for accounting review. `FOR_REVIEW`: ready for accounting review. `PENDING_SYNC`: sync is in progress. `SYNCED`: synced to the accounting system. `ERROR`: sync failed. `DO_NOT_SYNC`: marked to be excluded from sync. `EXPORTED`: exported for accounting. `NOT_SYNCABLE`: this record cannot be synced. `AUTO_SYNC`: ready to be synced automatically. Null when no sync state is set.
Known values: NOT_FINALIZED, FOR_REVIEW, PENDING_SYNC, SYNCED, ERROR, DO_NOT_SYNC, EXPORTED, NOT_SYNCABLE, AUTO_SYNC
gl_vendorobjectOptionalVendor in the connected accounting system.
gl_vendor.gl_vendor_idstringOptionalID of the vendor in the accounting system.
gl_vendor.idstringOptionalID of the accounting vendor in Rippling.
gl_vendor.namestringOptionalName of the vendor in the accounting system.
idstringRequired within parentIdentifier field
invoiceobjectOptionalInvoice file and its filename.
invoice.file_namestringOptionalOriginal file name, when recorded.
invoice.urlstringRequired within parentURL for accessing the file.
invoice_datestringOptionalInvoice date, as an ISO 8601 date (YYYY-MM-DD). Null when not set. Filters compare UTC calendar days: `eq` includes the whole day, `gt` starts the following day, and `lt` excludes the specified day. `ge` and `le` include the specified day; `in` matches any listed day.
invoice_numberstringOptionalInvoice number. Null when the bill has no invoice number.
line_itemsarrayOptionalCategory splits of the transaction amount.
line_items[]ModelEach itemExpand Retrieve a specific bill — response body — line items item
memostringOptionalMemo entered on the transaction.
merchant_amountobjectOptionalAmount charged by the merchant, in the merchant currency. The `value` is a decimal string.
merchant_amount.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
merchant_amount.valueJSONOptional
merchant_amount.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
merchant_amount.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
parent_bill_idstringOptionalID of the bill this payment was split from. Use it with `/bills/{id}/`. Null when it is not a split bill.
payment_amountobjectOptionalAmount paid to the vendor, in the payment currency. The `value` is a decimal string.
payment_amount.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
payment_amount.valueJSONOptional
payment_amount.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
payment_amount.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
payment_method_feeobjectOptionalPayment method fee, in the company's headquarters currency. The `value` is a decimal string. Zero when there is no fee.
payment_method_fee.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
payment_method_fee.valueJSONOptional
payment_method_fee.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
payment_method_fee.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
payment_schedule_settingstringOptionalPayment scheduling choice: `SCHEDULE_NOW` to schedule payment, or `SKIP_FOR_NOW` to defer scheduling.
Known values: SCHEDULE_NOW, SKIP_FOR_NOW
payment_velocitystringOptionalPayment speed option: `TWO_DAY` (accelerated) or `FOUR_DAY` (standard). Use `estimated_payment_arrival` for the expected arrival date.
Known values: TWO_DAY, FOUR_DAY
scheduled_payment_datestringOptionalDate used to estimate vendor payment, as an ISO 8601 date. Null when not set.
submitterModelOptionalExpand Retrieve a specific bill — response body — submitter
submitter_idstringOptionalID of the bill manager who submitted the bill. Use it with `/workers/{id}/`. Can differ from `worker_id`. Null before submission.
transaction_typestringOptionalType of transaction: `BILL_PAYMENT`.
Known values: BILL_PAYMENT
updated_atstringRequired within parentRecord update date
vendorModelOptionalExpand Retrieve a specific bill — response body — vendor
vendor_idstringOptionalID of the Finance vendor. Use it with `/finance-vendors/{id}/`.
vendor_memostringOptionalMemo included on the payment to the vendor. Supported for ACH; null when not set.
vendor_paid_datestringOptionalDate the vendor is paid, as an ISO 8601 date. Null until paid.
workerModelOptionalExpand Retrieve a specific bill — response body — worker
worker_idstringOptionalID of the worker who made the transaction. Use it with `/workers/{id}/`.

Referenced models: Retrieve a specific bill — response body — line items item, Retrieve a specific bill — response body — attachments item, Retrieve a specific bill — response body — submitter, Retrieve a specific bill — response body — vendor, Retrieve a specific bill — response body — worker

List break policies — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
country_codestringOptionalISO 3166-1 alpha-2 country code the policy applies to (e.g. 'US', 'CA', 'GB').
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
is_defaultbooleanOptionalWhether this is a system-seeded default policy (true) or a custom policy created by an admin (false).
namestringRequired within parentThe display name of the break policy. For default policies this is the system-generated label (e.g. 'Default Break policy: All Workers | California'); for custom policies this is the admin-provided description.
updated_atstringRequired within parentRecord update date

List break types — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
break_categorystringOptionalThe break category. One of: MEAL, REST, or OTHER.
Known values: MEAL, REST, OTHER
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
is_paidbooleanOptionalWhether this is a paid break (true) or unpaid (false).
namestringRequired within parentThe display name of the break type.
policyModelOptionalExpand Retrieve a specific break type — response body — policy
policy_idstringOptionalThe ID of the break policy this break type belongs to.
updated_atstringRequired within parentRecord update date

Referenced models: Retrieve a specific break type — response body — policy

List business partner groups — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringRequired within parentRecord creation date
default_business_partnerModelOptionalExpand Create a new business partner group — response body — default business partner
default_business_partner_idstringOptionalId of Optional default business partner worker to whom all employees will be mapped if not explicitly mapped to a business partner in the group.
domainstringOptionalType of business partner group
Known values: HR, IT, FINANCE, RECRUITING, OTHER
idstringRequired within parentIdentifier field
namestringRequired within parentName used to identify business partner group
updated_atstringRequired within parentRecord update date

Referenced models: Create a new business partner group — response body — default business partner

List business partners — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
business_partner_groupModelOptionalExpand Create a new business partner — response body — business partner group
business_partner_group_idstringRequired within parentIdentifier of business partner group the business parter is a part of
client_groupModelOptionalExpand Create a new business partner — response body — client group
client_group_idstringOptionalIdentifier of group of workers associated with the business partner
client_group_member_countJSONOptional
client_group_member_count (anyOf 1)integerAlternativeNumber of workers associated with the business partner
client_group_member_count (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
updated_atstringRequired within parentRecord update date
workerModelOptionalExpand Create a new business partner — response body — worker
worker_idstringRequired within parentIdentifier of worker who is the business partner

Referenced models: Create a new business partner — response body — business partner group, Create a new business partner — response body — client group, Create a new business partner — response body — worker

List candidate applications — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
applied_atstringOptionalApplication creation date
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
jobobjectOptionalJob requisition

Expandable field
job.created_atstringRequired within parentRecord creation date
job.idstringRequired within parentIdentifier field
job.namestringRequired within parentJob requisition name
job.statusstringRequired within parentJob requisition status
Known values: OPEN, CLOSED, PUBLISHED, DRAFT, ARCHIVED
job.updated_atstringRequired within parentRecord update date
job_idstringOptionalJob requisition ID
stagestringOptionalApplication stage
statusstringOptionalApplication status
Known values: ACTIVE, REJECTED, HIRED, ARCHIVED
updated_atstringRequired within parentRecord update date
urlstringOptionalApplication url

List candidates — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringRequired within parentRecord creation date
emailstringOptionalCandidate email
first_namestringOptionalCandidate first name
idstringRequired within parentIdentifier field
last_namestringOptionalCandidate last name
phone_numberstringOptionalCandidate phone number
timezonestringOptionalCandidate timezone
updated_atstringRequired within parentRecord update date

List card transactions — response body — results item

FieldTypePresenceDescription and constraints
$objectRootA Finance card transaction or authorization the caller can see.

An authorization is a pending hold the card network places at the time of purchase. A card transaction
is the posted charge. List returns both; retrieve returns one by ID. A transaction the
caller cannot see returns 404, the same as one that does not exist.
accounting_datestringOptionalDate the transaction is booked in the accounting system, as an ISO 8601 date (YYYY-MM-DD).
approval_statusstringOptionalApproval status of the transaction. `DRAFT`: not submitted for approval. `PENDING`: awaiting required information or submission before approval. `REQUESTED`: submitted and awaiting approval. `APPROVED`: approved. `REJECTED`: rejected. `FINALIZED`: finalized for payment. `ACTIONED`: payment or reimbursement completed. `CANCELLED`: cancelled. `FAILED`: payment failed. Null for card authorizations.
Known values: DRAFT, PENDING, REQUESTED, APPROVED, REJECTED, FINALIZED, ACTIONED, CANCELLED, FAILED
attachmentsarrayOptionalOther attached files, including filenames and recorded upload metadata.
attachments[]ModelEach itemExpand Retrieve a specific bill — response body — attachments item
authorization_statestringOptionalState of the card authorization. `PENDING`: an active hold awaiting completion. `CLOSED`: the authorization completed and the charge posted. `REVERSED`: the authorization was reversed and the hold released. `EXPIRED`: the hold expired without completion. Null for posted card transactions.
Known values: PENDING, CLOSED, REVERSED, EXPIRED
card_idstringOptionalID of the Finance card used. No public API is currently available to retrieve this card.
company_amountobjectOptionalAmount in the company's headquarters currency. The `value` is a decimal string.
company_amount.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
company_amount.valueJSONOptional
company_amount.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
company_amount.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
created_atstringRequired within parentRecord creation date
entity_idstringOptionalID of the legal entity the transaction belongs to. Use it with `/company-legal-entities/{id}/`.
gl_sync_statestringOptionalState of the sync to the accounting system. `NOT_FINALIZED`: not ready for accounting review. `FOR_REVIEW`: ready for accounting review. `PENDING_SYNC`: sync is in progress. `SYNCED`: synced to the accounting system. `ERROR`: sync failed. `DO_NOT_SYNC`: marked to be excluded from sync. `EXPORTED`: exported for accounting. `NOT_SYNCABLE`: this record cannot be synced. `AUTO_SYNC`: ready to be synced automatically. Null when no sync state is set.
Known values: NOT_FINALIZED, FOR_REVIEW, PENDING_SYNC, SYNCED, ERROR, DO_NOT_SYNC, EXPORTED, NOT_SYNCABLE, AUTO_SYNC
gl_vendorobjectOptionalVendor in the connected accounting system.
gl_vendor.gl_vendor_idstringOptionalID of the vendor in the accounting system.
gl_vendor.idstringOptionalID of the accounting vendor in Rippling.
gl_vendor.namestringOptionalName of the vendor in the accounting system.
idstringRequired within parentIdentifier field
line_itemsarrayOptionalCategory splits of the transaction amount.
line_items[]ModelEach itemExpand Retrieve a specific bill — response body — line items item
memostringOptionalMemo entered on the transaction.
merchant_amountobjectOptionalAmount charged by the merchant, in the merchant currency. The `value` is a decimal string.
merchant_amount.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
merchant_amount.valueJSONOptional
merchant_amount.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
merchant_amount.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
receiptobjectOptionalReceipt file and its filename.
receipt.file_namestringOptionalOriginal file name, when recorded.
receipt.urlstringRequired within parentURL for accessing the file.
transaction_datestringOptionalWhen the purchase or authorization happened, as an ISO 8601 date-time in UTC.
transaction_typestringOptional`CARD_TRANSACTION`: a posted card charge. `CARD_AUTHORIZATION`: a hold placed by the card network before the charge posts.
Known values: CARD_TRANSACTION, CARD_AUTHORIZATION
updated_atstringRequired within parentRecord update date
vendorModelOptionalExpand Retrieve a specific card transaction — response body — vendor
vendor_idstringOptionalID of the Finance vendor. Use it with `/finance-vendors/{id}/`.
workerModelOptionalExpand Retrieve a specific card transaction — response body — worker
worker_idstringOptionalID of the worker who made the transaction. Use it with `/workers/{id}/`.

Referenced models: Retrieve a specific bill — response body — line items item, Retrieve a specific bill — response body — attachments item, Retrieve a specific card transaction — response body — vendor, Retrieve a specific card transaction — response body — worker

List companies — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringRequired within parentRecord creation date
doing_business_as_namestringOptionalThe doing business as name for the company.
idstringRequired within parentIdentifier field
legal_entitiesarrayRequired within parentA list of the company's entities.

Expandable field
legal_entities[]ModelEach itemExpand Retrieve my SSO information — response body — company legal entities item
legal_entities_idarrayRequired within parentA list of the company's entities.
legal_entities_id[]stringEach item
legal_namestringOptionalThe legal name of the company.
namestringRequired within parentThe name of the company.
parent_legal_entityModelOptionalExpand Retrieve my SSO information — response body — company parent legal entity
parent_legal_entity_idstringOptionalThe company's ultimate holding entity.
phonestringOptionalThe phone number for the company.
physical_addressModelOptionalExpand Retrieve my SSO information — response body — company physical address
primary_emailstringOptionalThe email address used when registering this company.
updated_atstringRequired within parentRecord update date

Referenced models: Retrieve my SSO information — response body — company legal entities item, Retrieve my SSO information — response body — company parent legal entity, Retrieve my SSO information — response body — company physical address

List company legal entities — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
company_idstringOptionalThe company associated with this entity relationship.
country_codestringOptionalThe ISO country code for the entity.
created_atstringRequired within parentRecord creation date
entity_levelstringOptionalThe entity's level in a hierarchy. * `PARENT`: The legal entity is considered the ultimate holding entity. * `SUBSIDIARY`: The legal entity is considered a subsidiary, fully or partially held by another. * `BRANCH`: The legal entity is considered a branch, associated with a parent legal entity.
Known values: PARENT, SUBSIDIARY, BRANCH
idstringRequired within parentIdentifier field
is_archivedbooleanOptionalTrue if this entity relationship has been archived.
is_corbooleanOptionalTrue if this entity is managed as a Contractor of Record.
is_eorbooleanOptionalTrue if this entity is managed as an Employer of Record.
is_peobooleanOptionalTrue if this entity is managed as a Professional Employment Organization.
legal_namestringOptionalThe legal name of the entity.
mailing_addressModelOptionalExpand Retrieve a specific company legal entity — response body — mailing address
management_typestringOptionalThe entity management type. * `EOR`: The entity is managed as an Employer of Record. * `COR`: The entity is managed as a Contractor of Record. * `PEO`: The entity is managed as a Professional Employment Organization. * `null`: The entity is a direct hire with no managed employment type.
Known values: PEO, EOR, COR
physical_addressModelOptionalExpand Retrieve a specific company legal entity — response body — physical address
registration_datestringOptionalThe registration date of the entity.
tax_identifierstringOptionalThe tax identifier for this entity.
updated_atstringRequired within parentRecord update date

Referenced models: Retrieve a specific company legal entity — response body — mailing address, Retrieve a specific company legal entity — response body — physical address

List company-legal-entity-workers — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
company_entity_idstringOptionalThe worker's associated company legal entity (CER ID).
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
statusstringOptionalThe worker's status within the organization.
Known values: INIT, HIRED, ACCEPTED, ACTIVE, TERMINATED
updated_atstringRequired within parentRecord update date

List compensation bands details — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
internal_job_codestringOptionalInternal job code
updated_atstringRequired within parentRecord update date
workerModelOptionalExpand Retrieve a specific compensation bands detail — response body — worker
worker_idstringOptionalID of the worker associated with compensation bands

Referenced models: Retrieve a specific compensation bands detail — response body — worker

List compensations — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
annual_compensationobjectOptionalThe worker's annual compensation. This calculation assumes 40-hour work weeks for workers with an hourly wage.
annual_compensation.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
annual_compensation.valueJSONOptional
annual_compensation.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
annual_compensation.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
annual_salary_equivalentobjectOptionalThe worker's annual salary equivalent, for insurance purposes. It will be equal to the worker's annual compensation, except for owners that are receiving no cashcompensation.
annual_salary_equivalent.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
annual_salary_equivalent.valueJSONOptional
annual_salary_equivalent.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
annual_salary_equivalent.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
bonus_schedulestringOptionalThe worker's bonus schedule.
created_atstringRequired within parentRecord creation date
hourly_wageobjectOptionalThe worker's hourly wage. This calculation assumes 40-hour work weeks for workers with fixed compensation.
hourly_wage.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
hourly_wage.valueJSONOptional
hourly_wage.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
hourly_wage.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
idstringRequired within parentIdentifier field
monthly_compensationobjectOptionalThe worker's monthly compensation. This calculation assumes 40-hour work weeks for workers with an hourly wage.
monthly_compensation.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
monthly_compensation.valueJSONOptional
monthly_compensation.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
monthly_compensation.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
on_target_commissionobjectOptionalThe worker's on-target commission.
on_target_commission.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
on_target_commission.valueJSONOptional
on_target_commission.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
on_target_commission.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
payment_termsstringOptionalThe payment terms for an worker's compensation.
payment_typestringOptionalThe payment type for an worker's compensation.
relocation_reimbursementobjectOptionalThe worker's hourly wage. This calculation assumes 40-hour work weeks for workers with fixed compensation.
relocation_reimbursement.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
relocation_reimbursement.valueJSONOptional
relocation_reimbursement.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
relocation_reimbursement.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
salary_effective_datestringOptionalSalary effective date
signing_bonusobjectOptionalThe worker's signing bonus.
signing_bonus.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
signing_bonus.valueJSONOptional
signing_bonus.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
signing_bonus.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
target_annual_bonusobjectOptionalThe worker's target annual bonus amount.
target_annual_bonus.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
target_annual_bonus.valueJSONOptional
target_annual_bonus.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
target_annual_bonus.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
target_annual_bonus_percentJSONOptional
target_annual_bonus_percent (anyOf 1)numberAlternativeThe worker's target annual bonus as a percent of annual compensation.
target_annual_bonus_percent (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
updated_atstringRequired within parentRecord update date
weekly_compensationobjectOptionalThe worker's weekly compensation. This calculation assumes 40-hour work weeks for workers with an hourly wage.
weekly_compensation.currency_typestringOptionalThe currency type, ex: USD, EUR, etc.
weekly_compensation.valueJSONOptional
weekly_compensation.value (anyOf 1)numberAlternativeThe decimal amount for the currency.
weekly_compensation.value (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
workerModelOptionalExpand Retrieve a specific compensation — response body — worker
worker_idstringOptionalThe worker's ID.

Referenced models: Retrieve a specific compensation — response body — worker

List custom fields — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringRequired within parentRecord creation date
descriptionstringOptionalThe description of the custom field.
idstringRequired within parentIdentifier field
namestringRequired within parentThe name of the custom field.
optionsarrayOptionalThe available choice values for SELECT and RADIO custom fields. Null for other field types.
options[]stringEach item
requiredbooleanOptionalWhether the custom field is required.
typestringRequired within parentThe data type of the custom field.
Known values: TEXT, DATE, NUMBER, CURRENCY, PERCENTAGE, SELECT, FILE, ID, RADIO, TEXTAREA, RANGE, REFERENCE_ID, BOOLEAN, ADDRESS, OG_REFERENCE_FIELD, NATIVE_EDGE, DATETIME, EMAIL, URL
updated_atstringRequired within parentRecord update date

List custom object fields — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
api_namestringRequired within parentThe api name of the custom object field
created_atstringRequired within parentRecord creation date
custom_objectstringRequired within parentThe custom object which the field belongs to
data_typeobjectRequired within parentThe data type configuration for the field.
Additional keys: allowed
data_type.num_of_decimal_placesJSONOptional
data_type.num_of_decimal_places (anyOf 1)integerAlternativeConfigured fractional scale for NUMBER, PERCENTAGE, and CURRENCY fields. Availability above the legacy per-type limit is capability-gated.
Maximum: 15
Minimum: 0
data_type.num_of_decimal_places (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
descriptionstringOptionalThe description of the custom object field
enable_historybooleanRequired within parentwhether the history is enable for the field
idstringRequired within parentIdentifier field
is_immutablebooleanRequired within parentwhether the field is imuatable
is_standardbooleanRequired within parentwhether the field is standard field
is_uniquebooleanRequired within parentThis field specifies whether a particular column value has unique values
managed_package_install_idstringOptionalThe id of the package which the custom object field belongs to
namestringRequired within parentThe name of the custom object field
updated_atstringRequired within parentRecord update date

List custom object list views — response body — results item

FieldTypePresenceDescription and constraints
$objectRootA saved Custom Object grid configuration for selecting, filtering, and ordering records.
api_namestringRequired within parentStable API name used to address this view.
capabilitiesModelRequired within parentExpand Create a custom object list view — response body — capabilities
columnsarrayRequired within parentVisible columns, in saved display order.
columns[]ModelEach itemExpand Create a custom object list view — response body — columns item
created_atstringRequired within parentTime the view was created, as an ISO 8601 timestamp in UTC.
Format: date-time
descriptionJSONOptional
description (anyOf 1)stringAlternativeCreator-provided explanation of the records or purpose of this saved view. Null when no explanation was saved.
description (anyOf 2)nullAlternative
has_filterbooleanRequired within parentWhether this view applies a saved filter in addition to record_scope. The server resolves it when view_api_name is supplied to record queries.
idstringRequired within parentRead-only internal identifier; address operations using api_name.
is_defaultbooleanRequired within parentWhether this is the company's default view for this object.
namestringRequired within parentDisplay name of the saved view.
order_byJSONOptional
order_by (anyOf 1)stringAlternativeSaved ordering as one field API name, a space, and lowercase asc or desc, for example name asc. Null means no saved ordering.
order_by (anyOf 2)nullAlternative
record_scopestringRequired within parentMY_RECORDS restricts owners to the authenticated requester when the view is used.
Known values: ALL, MY_RECORDS
updated_atstringRequired within parentTime the view was last updated, as an ISO 8601 timestamp in UTC.
Format: date-time
visibilitystringRequired within parentPRIVATE belongs to its creator; SHARED is visible within the company. Neither grants record access.
Known values: PRIVATE, SHARED

Referenced models: Create a custom object list view — response body — columns item, Create a custom object list view — response body — capabilities

List custom objects — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
api_namestringOptionalThe api name of the custom object
category_idstringRequired within parentThe category of the custom object
created_atstringRequired within parentRecord creation date
descriptionstringOptionalThe description of the custom object
enable_historybooleanRequired within parentWhether to record the history of the custom object
idstringRequired within parentIdentifier field
managed_package_install_idstringOptionalThe id of the package which the custom object belongs to
namestringRequired within parentThe name of the custom object
native_category_idstringOptionalThe native category of the custom object if belongs to
owner_idstringOptionalThe id of the owner for the custom object
plural_labelstringRequired within parentThe plural label of the custom object
updated_atstringRequired within parentRecord update date

List developer program application — response body — results item

FieldTypePresenceDescription and constraints
$objectRootDeveloper Program application resource for Path B existing-company apply.
build_descriptionstringOptionalWhat the company plans to build on Rippling
company_idstringOptionalRippling company ID on the application
emailstringOptionalApplicant email on the application
expires_atstringOptionalTime after which ops can no longer approve this pending application
idstringRequired within parentStable application ID
role_idstringOptionalApplicant role ID
signup_idstringOptionalDeprecated alias of id. Prefer id.
stagesModelOptionalExpand Create a new developer program application — response body — stages
statusstringOptionalApplication status: EMAIL_VERIFICATION_PENDING, SUBMITTED, APPROVED, VERIFIED, REJECTED, or EXPIRED. Existing-company apply writes SUBMITTED and never EMAIL_VERIFICATION_PENDING. VERIFIED means provision finished, not email verified.
Known values: EMAIL_VERIFICATION_PENDING, SUBMITTED, APPROVED, VERIFIED, REJECTED, EXPIRED
submitted_atstringOptionalTime the application was submitted

Referenced models: Create a new developer program application — response body — stages

List device orders — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
cancel_requestedbooleanOptionalTrue when a cancellation has been requested but not yet completed.
completed_atstringOptionalWhen the order reached a terminal state (COMPLETED, FAILED, or CANCELED).
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
order_typestringOptionalThe type of hardware order, as reported by the underlying inventory order (for example: New Device Order, Warehouse Return, Warehouse Order, Add Existing Device, Assign Device, Empty Order, or Sell Device).
requested_by_idstringOptionalThe ID of the role that requested the order (often an IT admin). Null if system-created.
statusstringOptionalThe order lifecycle state (InventoryFlowState): CREATED, RUNNING, COMPLETED, FAILED, CANCELING, CANCELED.
updated_atstringRequired within parentRecord update date
warehouse_providerstringOptionalThe warehouse / vendor provider servicing the order (e.g. CDW, INGRAMMICRO, TD_SYNNEX, GROWRK).
workerModelOptionalExpand Retrieve a specific device order — response body — worker
worker_idstringOptionalThe ID of the worker the order is for (the recipient). Null if unassigned.

Referenced models: Retrieve a specific device order — response body — worker

List devices — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringRequired within parentRecord creation date
enrollment_statusstringOptionalThe MDM enrollment status: ENROLLED, UNENROLLED, WAITING_FOR_CONNECTION, ERROR, etc.
Known values: ENROLLED, WAITING_FOR_CONNECTION, ERROR, UNENROLLED
idstringRequired within parentIdentifier field
is_encryptedbooleanOptionalWhether the device's disk is encrypted (FileVault on macOS, BitLocker on Windows).
is_managedbooleanOptionalWhether the device is managed via MDM.
last_checkin_atstringOptionalWhen the Rippling agent last checked in from this device.
last_mdm_sync_atstringOptionalWhen the device last synced with MDM.
lifecycle_statestringOptionalThe device lifecycle state (e.g. ACTIVE, READY, LOCKED, LOST, DECOMMISSIONED).
Known values: INIT, ACTIVE, ACTIVATING, LOCKED, LOCKING, INACTIVE, PENDING_MDM, CLEANING, READY, DECOMMISSIONING, DECOMMISSIONED, FULL_WIPING, FULL_WIPED, E_CYCLED, SOLD, MDM_LOCKED, LOST, LOST_PLAYING_SOUND
mdm_providerstringOptionalThe MDM provider currently recorded on the device (RIPPLING, JAMFCLOUD, INTUNE, KANDJI, etc.). Null when the device is not currently MDM-managed (typical for unenrolled or recently-reset devices).
Known values: RIPPLING, JUMPCLOUD, JAMFCLOUD, FLEETSMITH, HEXNODE, MICROMDM, MERAKI, SOTI, ADDIGY, FLEETDM, KANDJI, ZOHO, INTUNE, OTHER
modelstringOptionalThe device hardware model identifier as reported by MDM (e.g. 'MacBookPro18,3', 'iPhone15,2').
os_namestringOptionalThe device operating system name.
os_versionstringOptionalThe device operating system version.
pending_actionsarrayOptionalActions currently queued against the device (not yet completed). Expandable.

Expandable field
pending_actions[]ModelEach itemExpand Retrieve a specific device — response body — pending actions item
pending_actions_idarrayOptionalThe IDs of actions currently queued against the device (not yet completed).
pending_actions_id[]stringEach item
platformstringOptionalThe OS platform the device runs: MACOS, WINDOWS, IOS, or IPADOS.
Known values: MACOS, WINDOWS, IOS, IPADOS
serial_numberstringOptionalThe device's hardware serial number.
updated_atstringRequired within parentRecord update date
workerModelOptionalExpand Retrieve a specific device — response body — worker
worker_idstringOptionalThe ID of the worker this device is currently assigned to. Null if unassigned.

Referenced models: Retrieve a specific device — response body — pending actions item, Retrieve a specific device — response body — worker

List earning-types — response body — results item

FieldTypePresenceDescription and constraints
$objectRootAn earning category available in Global Payroll, such as salary, commission, or bonus.
country_codestringOptionalUppercase ISO 3166-1 alpha-2 country code of the payroll catalog, such as `CA` or `US`.
display_namestringOptionalConfigured display name of the earning type. Entries with different configurations can have the same name and `earning_code`.
earning_codestringOptionalCode used to select this earning type in `POST /earnings-inputs/`, such as `regular_salary` or `commission`. Availability is validated against the worker's payroll catalog.
idstringOptionalIdentifier of a source earning type. With `company_entity_id`, equivalent entries use one existing ID, which can change when its source entry is removed. Use `earning_code` when submitting payroll earnings inputs.

List earnings-inputs — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
V2 DTO representing an external earnings input record.

Used by:
- GET /earnings-inputs/ (list)
amountstringOptionalEarning amount as a string-encoded decimal.
assignment_typestringOptionalHow the earning is assigned (e.g. BY_PAY_PERIOD).
company_entity_idstringOptionalIdentifier for the legal entity (company entity relationship) this earning is associated with. Use this to correlate earnings with a specific legal entity in a multi-entity company.
earning_codestringOptionalCode identifying the earning type (e.g. regular_salary).
earning_end_datestringOptionalEnd of the period this earning was earned. Used for regular-rate-of-pay (RROP) attribution. Distinct from pay_period_basis_date, which selects the pay run.
earning_start_datestringOptionalStart of the period this earning was earned. Used for regular-rate-of-pay (RROP) attribution. Distinct from pay_period_basis_date, which selects the pay run.
external_idstringOptionalExternal reference identifier for this earning.
hoursstringOptionalHours associated with this earning as a string-encoded decimal.
idstringOptionalUnique identifier for the earnings input.
is_overriddenbooleanOptionalWhether this earning's amount was manually overridden instead of using the calculated value. Always false for newly created earnings.
pay_period_basis_datestringOptionalThe pay period basis date for this earning.
run_idstringOptionalIdentifier of the payroll run this earning is assigned to, if any.
statusstringOptionalCurrent status of the earnings input (e.g. UNASSIGNED, ASSIGNED).
time_labelsarrayOptionalTime tracking labels associated with this earning.
time_labels[]stringEach item
worker_idstringOptionalIdentifier of the worker (role ID).

List employment types — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
amount_workedstringOptionalThe amount worked for the employment type. * `FULL-TIME`: Full-time is at least 30 hours per week. Full-time workers will typically be eligible for benefits. * `PART-TIME`: Part-time is less than 30 hours per week. These workers may be eligible for benefits, depending on company settings and hours worked. * `TEMPORARY`: These workers are hired on a temporary basis. You can specify how each worker with this employment type will be paid individually.
Known values: PART-TIME, FULL-TIME, TEMPORARY
compensation_time_periodstringOptionalThe compensation period for the employment type. * `SALARIED`: Employees that are paid a fixed amount per year. * `HOURLY`: Employees that are paid a wage per hour worked.
Known values: HOURLY, SALARIED
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
labelstringRequired within parentThe display label of the employment type.
namestringOptionalThe name of the employment type for non-custom employment types.
typestringOptionalThe classification of the worker by the company. * `CONTRACTOR`: Contractors are self-employed workers who provide services on a short-term or per-project basis and are not eligible for tax-withholding or benefits. * `EMPLOYEE`: Employees are hired and managed by an employer, work under the employer's direct supervision and control, and are protected by law for wages and employment rights.
Known values: CONTRACTOR, EMPLOYEE
updated_atstringRequired within parentRecord update date

List entitlements — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
descriptionstringRequired within parentDescription of the entitlement
display_namestringRequired within parentDisplay name of the entitlement
idstringRequired within parentIdentifier field

List files in the active bundle — response body

FieldTypePresenceDescription and constraints
$objectRoot
bundle_idstringOptionalActive bundle identifier.
directoriesarrayOptionalDirectories in the listing scope.
directories[]ModelEach itemExpand List files in the active bundle — response body — directories item
entry_pathstringOptionalEntry path for the active bundle.
filesarrayOptionalFiles in the listing scope.
files[]ModelEach itemExpand List files in the active bundle — response body — files item
parent_pathstringOptionalDirectory path used for the listing.
recursivebooleanOptionalWhether the listing was recursive.

Referenced models: List files in the active bundle — response body — directories item, List files in the active bundle — response body — files item

List files in the active bundle — response body — directories item

FieldTypePresenceDescription and constraints
$objectRoot
namestringOptionalDirectory name.
parent_pathstringOptionalParent directory path.
pathstringOptionalNormalized directory path inside the active bundle.

List files in the active bundle — response body — files item

FieldTypePresenceDescription and constraints
$objectRoot
content_typestringOptionalMIME content type.
namestringOptionalFile name.
parent_pathstringOptionalParent directory path.
pathstringOptionalNormalized file path inside the active bundle.
sha256stringOptionalSHA-256 hash of the file contents.
size_bytesJSONOptional
size_bytes (anyOf 1)integerAlternativeFile size in bytes.
size_bytes (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$

List finance categories — response body — results item

FieldTypePresenceDescription and constraints
$objectRootA Finance category used to classify transaction line items.

Inactive categories are included so historical transactions can still resolve their category.
activebooleanOptionalWhether the category is active. Inactive categories remain available for historical references.
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
namestringOptionalName of the Finance category.
updated_atstringRequired within parentRecord update date

List finance vendors — response body — results item

FieldTypePresenceDescription and constraints
$objectRootA vendor in the company's Finance directory.

Stub and archived vendors are included so historical transactions can still resolve their vendor.
created_atstringRequired within parentRecord creation date
idstringRequired within parentIdentifier field
is_archivedbooleanOptionalWhether the vendor is archived. Archived vendors remain available for historical references.
logostringOptionalURL of the vendor's logo. Null when no logo is available.
namestringOptionalCanonical name of the Finance vendor. Name eq, ne, and in filters also match alternate names.
updated_atstringRequired within parentRecord update date

List function deployments — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
allowed_domainsarrayOptionalDomains that function runs from this deployment are allowed to access
allowed_domains[]stringEach item
codestringOptionalThe code for the deployment
created_atstringRequired within parentThe creation date of the deployment
dependenciesobjectOptionalThe dependencies of the deployment
external_idstringOptionalThe external ID of the deployment
function_api_namestringOptionalThe API name of the function that this deployment is associated with
function_idstringOptionalThe ID of the function that this deployment is associated with
function_version_human_friendly_idJSONOptional
function_version_human_friendly_id (anyOf 1)integerAlternativeThe human friendly ID of version that this deployment is associated with
function_version_human_friendly_id (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
function_version_idstringOptionalThe ID of the version that this deployment is associated with
idstringRequired within parentThe ID of the deployment
io_contractobjectOptionalInput and output JSON Schema contracts for the deployment
optionsobjectOptionalAdditional, runtime-specific options for the deployment
runtimestringOptionalThe runtime for the deployment
statusstringOptionalThe status of the deployment
updated_atstringRequired within parentThe last updated date of the deployment

List function execution logs — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
levelstringOptionalThe log level
messagestringRequired within parentThe log message
paramsobjectOptionalParameters associated with the log line
sequence_numJSONRequired within parent
sequence_num (anyOf 1)integerAlternativeThe sequence number of the log line
sequence_num (anyOf 2)stringAlternativePattern: ^-?[0-9]+(?:\.[0-9]+)?(?:[eE][+-]?[0-9]+)?$
timestampstringOptionalThe log timestamp

List function executions — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
created_atstringRequired within parentRecord creation date
finished_atstringOptionalThe end time of the execution
function_idstringRequired within parentThe ID of the function this execution belongs to
idstringRequired within parentIdentifier field
inputsobjectRequired within parentThe inputs of the execution
outputsobjectOptionalThe outputs of the execution
started_atstringOptionalThe start time of the execution
statusstringOptionalThe status of the execution
updated_atstringRequired within parentRecord update date

List functions — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
api_namestringOptionalThe API name of the function
code_draftstringOptionalThe current draft of code for the function
created_atstringRequired within parentRecord creation date
dependenciesobjectOptionalThe dependencies of the function
descriptionstringOptionalThe function description
idstringRequired within parentIdentifier field
is_asyncbooleanOptionalWhether this function runs asynchronously
listed_in_custom_appsbooleanOptionalWhether this request-function is listed in the Custom Apps grid and navigation. Defaults to false on creation; omitted updates preserve the current value. Listing does not grant access or change deployment behavior. Only supported for request functions. Setting this field on an event function returns a validation error.
namestringOptionalThe function name
source_upload_instructionsModelOptionalExpand Update a function — response body — source upload instructions
updated_atstringRequired within parentRecord update date

Referenced models: Update a function — response body — source upload instructions

List headcount positions — response body — results item

FieldTypePresenceDescription and constraints
$objectRoot
actual_compensationModelOptionalExpand Retrieve a specific headcount position — response body — actual compensation
backfill_forModelOptionalExpand Retrieve a specific headcount position — response body — backfill for
backfill_for_idstringOptionalID of the worker for whom this headcount position was requested as a backfill
comp_band_compensationModelOptionalExpand Retrieve a specific headcount position — response body — comp band compensation
created_atstringRequired within parentRecord creation date
current_start_datestringOptionalMost recent start date estimate or the actual hire date if already filled
departmentModelOptionalExpand Retrieve a specific headcount position — response body — department
department_idstringOptionalID for the department the headcount belongs to
employment_typeModelOptionalExpand Retrieve a specific headcount position — response body — employment type
employment_type_idstringOptionalID for the employment type the headcount is assigned to
end_datestringOptionalTargeted end date for the headcount
headcount_ownerModelOptionalExpand Retrieve a specific headcount position — response body — headcount owner
headcount_owner_idstringOptionalID for the headcount owner
idstringRequired within parentIdentifier field
in_budgetbooleanOptionalWhether the headcount position is in budget
job_functionobjectOptionalJob function assigned to this headcount

Expandable field
job_function.created_atstringRequired within parentRecord creation date
job_function.idstringRequired within parentIdentifier field
job_function.namestringOptionalDisplayed name of the job function
job_function.updated_atstringRequired within parentRecord update date
job_function_idstringOptionalID for the job function the headcount is assigned to
job_requisitionModelOptionalExpand Retrieve a specific headcount position — response body — job requisition
job_requisition_idstringOptionalID for the job requisition the headcount is associated with
levelModelOptionalExpand Retrieve a specific headcount position — response body — level
level_idstringOptionalID for the level the headcount is assigned to
location_factorModelOptionalExpand Retrieve a specific headcount position — response body — location factor
location_factor_idstringOptionalID for the location factor the headcount is assigned to
notesstringOptionalHeadcount notes
position_idstringOptionalPosition name for the headcount, for ex PID100037
[...]
